#include "interface.h"
#include "monster.h"

static int key_ok;

void ParseKey(turn_list* tl, coord_list* cl, map* map, int down, XKeyEvent event) {
        int areax   = event.x/TILE_SIZE, 
	    areay   = event.y/TILE_SIZE,
	    bufsize = 20,
	    charcount;

	monster* me;
	
	char buffer[20]; /* you can use the buffer if you want to print what you're typing */
	KeySym key;

	charcount = XLookupString(&event,buffer,bufsize,&key,(NULL));
	me = cl->cursor->who;


	if(down) {
		switch(key) {
			case XK_n     : key_ok = 1; moveToNearestMonster(cl,map,me,0); break;
			case XK_m     : key_ok = 1; moveToNearestMonster(cl,map,me,1); break;
			case XK_p     : key_ok = 1; moveToNearestMonster(cl,map,me,2); break;
			case XK_Up    : key_ok = 1; moveMonster(cl,map,me,0,-1,0); break;
			case XK_Down  : key_ok = 1; moveMonster(cl,map,me,0,1,0); break;
			case XK_Left  : key_ok = 1; moveMonster(cl,map,me,-1,0,0); break;
			case XK_Right : key_ok = 1; moveMonster(cl,map,me,1,0,0); break;
			default       : key_ok = 0; break;
		}
	} else {
		if(key_ok) tl->game_control=no_action;
	}
}

void ParseButton(turn_list* tl, coord_list* cl, map* map, int down, XButtonEvent event) {
        int areax  = event.x/TILE_SIZE,
	    areay  = event.y/TILE_SIZE,
	    winx   = event.x,
	    winy   = event.y,
	    button = event.button;

	monster* mos;

        printf("X: %d, Y: %d  button%d-%s\n",winx,winy,button,(down)?"pressed":"released");

        switch(button) {
        case 1:
                if(down) {
                        downx=areax;
                        downy=areay;
                } else {
                        relMoveMonster(cl,map,getMonster(cl,downx,downy),downx,downy,areax,areay);
                } break;
        case 2:
		if(down) {
			if(mos=map->cell[areax][areay]->mos) {
				printf("the %s on that space is called %s",
			               (mos->is_player)?"player":"monster",mos->name);
			}
		} else {
			
		} break;
        case 3:
		if(down) {

		} else {
                	printf("exit\n");
                	exit(0);
		} break;
        }

	if(!down) tl->game_control=no_action;
}     
