#include "lists.h"
#include "math.h"


void addMonster(turn_list *tl, coord_list *cl, map *map, monster* who, int x, int y) {
	addTurn(tl,who);
	addCoord(cl,who,x,y);
	mapAddMonster(map,who,x,y);
}

void delMonster(turn_list *tl, coord_list *cl, map *map, monster* who) {
	int x,y;

	delTurn(tl,who);
	
	x=getX(cl,who); y=getY(cl,who);
	delCoord(cl,who);

	mapDelMonster(map,x,y);
}

void moveMonster(coord_list *cl, map *map, monster* who, int dx, int dy,
                 int teleport) {
	mapMoveMonster(map,getX(cl,who),getY(cl,who),dx,dy,teleport);
	coordMoveMonster(cl,who,dx,dy,teleport);
}

void relMoveMonster(coord_list *cl, map *map, monster* who, 
                    int ox, int oy, int tox, int toy) {
	int movex,movey,dx=(tox-ox),dy=(toy-oy);

	if(dx==0 && dy==0) { 
		movex=0; 
		movey=0; 
	} else if(dx==0 && dy!=0) { 
		if(dy>0) { 
			movex=0; 
			movey=1; 
		} else { 
			movex=0; 
			movey=-1; 
		}
	} else if(dx!=0 && dy==0) { 
		if(dx>0) { 
			movex=1; 
			movey=0; 
		} else {
			movex=-1;
			movey=0; 
		}
	} else { 
		if(dx>0) {
			if(dy>0) {
				movex=1;
				movey=1;
			} else {
				movex=1;
				movey=-1;
			}
		} else {
			if(dy>0) {
				movex=-1;
				movey=1;
			} else {
				movey=-1;
				movex=-1;
			}
		}
	} 
	moveMonster(cl,map,who,movex,movey,0);
}

monster* nearestMonster(coord_list *cl, map *map, monster* who,
                        int friendfoe) {
	coord_node *temp;
	monster    *gotcha=NULL;

	int whox,whoy,bestx,besty,dx,dy,bdx=-1,bdy;

	temp=cl->cursor;
	while(temp->who!=who) temp=temp->next;

	whox=temp->x;
	whoy=temp->y;
	
	temp=temp->next;

	while(temp->who!=who) {
		dx = abs(whox - temp->x);
		dy = abs(whoy - temp->y);
		if(friendfoe==0 || (friendfoe==1 && temp->who->is_player==0) 
                                || (friendfoe==2 && temp->who->is_player==1)) {
			if(bdx==-1) {
				bdx=dx;
				bdy=dy;
				gotcha=temp->who;
			}
			if(((dx*dx)+(dy*dy))<((bdx*bdx)+(bdy*bdy))) { 
				bdx=dx;
				bdy=dy;
				printf("-%d,%d-\n",bdx,bdy);
				gotcha=temp->who;
			}
		}
		temp=temp->next;
	}
	printf("NEAREST MONSTER: %s\n",(gotcha)?gotcha->name:"no monster");
	return gotcha;
}

void moveToMonster(coord_list *cl, map *map, monster* who, monster* to) {
	relMoveMonster(cl,map,who,getX(cl,who),getY(cl,who),getX(cl,to),getY(cl,to));
}

void moveToNearestMonster(coord_list *cl, map *map, monster* who, int friendfoe) {
	monster* nearest;
	if(nearest=nearestMonster(cl,map,who,friendfoe)) {
		moveToMonster(cl,map,who,nearest);
	}
}

char* getName(map *map, int x, int y) {
	if(map->cell[x][y]->mos)
		return map->cell[x][y]->mos->name;
	return NULL;
}
