#include <stdlib.h>
#include "lists.h"
#include "area.h"

turn_list* newTurnList() {
	turn_list* new;
	new=(turn_list*)malloc(sizeof(turn_list));
	new->cursor=NULL;

	return new;
}

void delTurnList(turn_list* list) {

}

void addTurn(turn_list* list, monster* who) {
	turn_node *new, *temp;

	new=(turn_node*)malloc(sizeof(turn_node));
	new->who=who;

	if(list->cursor==NULL) {
		list->cursor=new;
		list->cursor->next=new;
	} else {
		temp=list->cursor->next;
		list->cursor->next=new;
		list->cursor->next->next=temp;
	}
	
	decideGameControl(list);
}

monster* whoTurn(turn_list* list) {
	decideGameControl(list);
	if(list->cursor) return list->cursor->who;
	return NULL;
}

void delTurn(turn_list* list, monster* who) {
	turn_node *cur, *prev;

	cur=prev=list->cursor;
	if(cur) {
		while(cur->who!=who) {
			cur=cur->next;
		}
		while(prev->next!=cur) {
			prev=prev->next;
		}
		if(cur!=prev) {
			prev->next=cur->next;
			free(cur);
			cur=NULL;
			list->cursor=prev->next;
		} else {
			free(cur);
			list->cursor=NULL;
		}
	} else {
		printf("there's no list!\n");
	}
	
	decideGameControl(list);
}

void nextTurn(turn_list* list) {
	if(list->cursor) list->cursor=list->cursor->next;
	decideGameControl(list);
}

void doTurn(turn_list* tl, coord_list* cl, map* map) {
	monster *who=whoTurn(tl);

	if(tl->game_control==pc) {
		listen(tl,cl,map,who);
	} else {
                todo(tl,cl,map,who);
	}

	areaStupidRefresh(map);
	PasteBufferToWindow();
	
	nextTurn(tl);
}

void decideGameControl(turn_list* list) {

	if(list->cursor) {
		if(list->cursor->who->is_player) list->game_control=pc;
		else                             list->game_control=npc;
	} else {
		list->game_control=no_action;
	} 
}

void dealTurn(turn_list* tl, coord_list* cl, map* map) {
	turn_node *temp;

	if(tl->cursor) {
		temp=tl->cursor;
		doTurn(tl,cl,map);
		while(temp->who!=whoTurn(tl))	{
			doTurn(tl,cl,map);
		}
	}
}
