#ifndef TURN_H
#define TURN_H

#include "monster.h"
#include "coord.h"
#include "map.h"

static int game_control;
enum game_control_options{no_action,npc,pc};

typedef struct turn_node {
	monster*         who;
	struct turn_node* next;
} turn_node;

typedef struct turn_list {
	turn_node* cursor;
	int        game_control;
} turn_list;

turn_list* newTurnList();
void delTurnList(turn_list* list);

void addTurn(turn_list* list, monster* who);
monster* whoTurn(turn_list* list);
void delTurn(turn_list* list, monster* who);
void nextTurn(turn_list* list);

void doTurn(turn_list* tl, coord_list* cl, map* map);
void dealTurn(turn_list* tl, coord_list* cl, map* map);

void decideGameControl(turn_list* list);

#endif /* TURN_H */
