#include "xfuncs.h"

void GrabStuff(void) {
        XGrabServer(display);
        XGrabPointer(display, MapWin, True, ButtonPressMask | ButtonReleaseMask | PointerMotionMask, GrabModeAsync, GrabModeAsync, MapWin, None, CurrentTime);
        XGrabKeyboard(display, MapWin, True, GrabModeAsync, GrabModeAsync, CurrentTime);
}

void CreateWindow(int winx,int winy,int winw,int winh,char *wintitle) {
        XSetWindowAttributes WinAttr;
        XTextProperty        WindowName;
        XSizeHints          *SizeHints;
        XWMHints            *WMHints;
        XClassHint          *ClassHints;
        XGCValues            GCV;
        XColor               Cell;

        int x;


        WinAttr.background_pixel=0;
        WinAttr.colormap=DefaultColormap;
        MapWin = XCreateWindow(display, RootWin, winx, winy, winw, winh, 0, CopyFromParent, InputOutput, CopyFromParent, CWColormap | CWBackPixel , &WinAttr);

        if (!(SizeHints = XAllocSizeHints()))
          {printf("Error allocating X-structure (size-hints)\n");exit(-1);}
        if (!(ClassHints = XAllocClassHint()))
          {printf("Error allocating X-structure (class-hints)\n");exit(-1);}
        if (!(WMHints = XAllocWMHints()))
          {printf("Error allocating X-structure (WM-hints)\n");exit(-1);}
        if (!XStringListToTextProperty(&wintitle, 1, &WindowName))
          {printf("Error allocating X-structure (window-name)\n");exit(-1);}

        /* set size hints */
        SizeHints->flags = PPosition | PSize;
        SizeHints->x = winx;
        SizeHints->y = winy;
        SizeHints->width = winw;
        SizeHints->height = winh;
        /* set class hints */
        ClassHints->res_name = "Pasta";
        ClassHints-> res_class = "Pasta";
        WMHints->flags = 0;   /* no wm hints */
        XSetWMProperties(display, MapWin, &WindowName, &WindowName, NULL, 0, SizeHints, WMHints, ClassHints);

        XFree(SizeHints);
        XFree(WMHints);
        XFree(ClassHints);


        XSelectInput(display, MapWin, ButtonPressMask | ButtonReleaseMask | PointerMotionMask | KeyPressMask | KeyReleaseMask | ExposureMask | SubstructureNotifyMask);

        if (!(questFont = XLoadQueryFont(display, TextFont)))
        {
                printf("Could not open font %s\n", TextFont);
                exit(-1);
        }
        GCV.font = questFont->fid;
 
        questGC = XCreateGC(display, RootWin, 0, &GCV);
        XMapWindow(display, MapWin);

        for (x = 0; x < 256; x++)
        {
                Cell.pixel = x;
                Cell.flags = DoRed | DoGreen | DoBlue;
                XQueryColor(display, DefaultColormap, &Cell);
        }

        return;
}

void InitXWindows() {
        //w get display and info etc etc...
        int x,y;

        if ( (display = XOpenDisplay(NULL)) == NULL )
        {
                printf("display error\n");
                exit( -1 );
        }

        ScreenNum = DefaultScreen(display);
        RootWin = RootWindow(display, ScreenNum);
        DefaultVisual = DefaultVisual(display,ScreenNum);
        DefaultColormap = DefaultColormap(display,ScreenNum);
        ScreenWidth = DisplayWidth(display, ScreenNum);
        ScreenHeight = DisplayHeight(display, ScreenNum);
}


Pixmap ChoosePixmap(monster* mos) {

        if(mos == NULL) return emptyPixmap;
        else  {
                if(mos->is_player) return pcPixmap;
                else               return npcPixmap;
        }
}

void StupidRefresh(map* map, int MapX, int MapY) {
        int i,j,WindowX, WindowY;

        for(j=0;j<YSPACES;j++) {
                for(i=0;i<XSPACES;i++) {
                        WindowX=i*TILE_SIZE;
                        WindowY=j*TILE_SIZE;
                        XCopyArea(display, ChoosePixmap(map->cell[MapX+i][MapY+j]->mos), bufferPixmap, questGC, 0, 0, TILE_SIZE, TILE_SIZE, WindowX, WindowY);
                        XFlush(display);
                }
        }
        XSync(display,0);
}

void PasteBufferToWindow() {
        XCopyArea(display, bufferPixmap, MapWin, questGC, 0, 0, XSPACES*TILE_SIZE, YSPACES*TILE_SIZE, 0, 0);
}

void LoadPixmaps() {

        //w the bufferPixmap is a pixmap I where I update all the changes
        //w to the screen, then when everything is ready I put THIS pixmap
        //w in the window, I don't go refresh the window for every little fart.
        bufferPixmap = XCreatePixmap(display, MapWin, XSPACES*TILE_SIZE, YSPACES*TILE_SIZE, DefaultDepth(display, DefaultScreen(display)));

        //w reading the xpm files and making pixmaps from them.
        XpmReadFileToPixmap(display, MapWin, "./xpm/empty.xpm", &emptyPixmap,
                            (Pixmap *) NULL, (XpmAttributes *) NULL);

        XpmReadFileToPixmap(display, MapWin, "./xpm/monster.xpm", &npcPixmap,
                            (Pixmap *) NULL, (XpmAttributes *) NULL);

        XpmReadFileToPixmap(display, MapWin, "./xpm/player.xpm", &pcPixmap,
                            (Pixmap *) NULL, (XpmAttributes *) NULL);
} 

void PrintCommandlineHelp() {
        printf("\nQuest 0.0.3\n\nThe current mouse functions are:\nLeft   - hacky function, move any monster\nMiddle - print the monster's name\nRight  - exit program\n\nThe keyboard:\nn      - move to nearest being\np      - move to nearest player\nm      - move to nearest monster\nleft   - move left\nright  - move right\nup     - move up\ndown   - move down\n\nThe signals (like ^C) aren't dealt with in a proper way yet,\nand I have to do something about the refresh event\nwhen another window has been on top of the map window, but who cares...\n\nWARNING: This test version will stop after 100 turns have passed! ;)\n\nHave fun...\n\n");
}

void InitMapWindow(map* map) {

        PrintCommandlineHelp();

        InitXWindows();

        //w the 50,50 are root screen coordinates where to put the window
        CreateWindow(50,50,XSPACES*TILE_SIZE,YSPACES*TILE_SIZE,
                     "Quest 0.0.3 - The Chase!");

        LoadPixmaps();

        areaStupidRefresh(map);

        //w and here goes the finished buffer pixmap into the window
        PasteBufferToWindow();
}
