#ifndef XFUNCS_H
#define XFUNCS_H

#include <stdlib.h>
#include <stdio.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>

#include <X11/xpm.h>

/* for functions I still have to improve:
   the signal handler and wait() */
#include <signal.h> 
#include <time.h>

#include "monster.h"
#include "area.h"
#include "lists.h"


typedef int bool;
#define true       (1)
#define false      (0)


static int TILE_SIZE = 16,
           XSPACES   = 32,
           YSPACES   = 32;

Display  *display;
Window   RootWin,
         MapWin;
Visual   *DefaultVisual;
GC       questGC;
XImage   *questI;
Colormap DefaultColormap,
         questColormap;
XColor   ColorCount[256];

char     *Image,
         *Background;
int      ScreenWidth,
         ScreenHeight,
         ScreenNum;

unsigned long int *Image32,
                  *Background32;

XFontStruct *questFont;
static char *TextFont = "lucidasanstypewriter-bold-24",
            *DisplayString = NULL;


int downx,
    downy;

/* for now a few pixmaps to draw with,
   later we make a list of all the pixmaps we use. */

Pixmap bufferPixmap,
       npcPixmap,
       pcPixmap,
       emptyPixmap;



void GrabStuff(void);
void CreateWindow(int winx,int winy,int winw,int winh,char *wintitle);
void InitXWindows();

void StupidRefresh(map* map, int MapX, int MapY);

Pixmap ChoosePixmap(monster* mos);
void LoadPixmaps();
void PasteBufferToWindow();

void PrintCommandlineHelp(); 
void InitMapWindow(map* map);


#endif /* XFUNCS_H */
